<?PHP
/*
	message_replace
	A regex replace so messages can include variables
	$message = the message you want to add the variables to
	$var1-9 = unneded variables to include in the message.
*/

function message_replace($message,$var1=NULL,$var2=NULL,$var3=NULL,$var4=NULL,$var5=NULL,$var6=NULL,$var7=NULL,$var8=NULL,$var9=NULL) {
	$patterns = array(
		'/%1%/i',
		'/%2%/i',
		'/%3%/i',
		'/%4%/i',
		'/%5%/i',
		'/%6%/i',
		'/%7%/i',
		'/%8%/i',
		'/%9%/i');
	$variables = array (
		$var1,
		$var2,
		$var3,
		$var4,
		$var5,
		$var6,
		$var7,
		$var8,
		$var9);
	$replaced = preg_replace($patterns, $variables, $message);
	return $replaced;
}

/*
	make_alert($alert_id, $device_id, $variable)
	This constructs the email alert list
	NOTE: $variable is not an array but the next function to use the database will assume any commas (,) is a marker to seperate arrays
			so please remove any commas unless you are wanting it as an array.
*/
function make_alert($alert_id, $device_id, $variable=NULL) {
	$alert = NULL;
	$db_handle4 = new PDO("sqlite:databases/faults.database.sqlite3");
	
	//Check for the Alert
	$db_query = $db_handle4->query("SELECT issue_id FROM faults WHERE device_id = '".$device_id."' AND vars = '".$variable."';");
	foreach($db_query as $row) {
		$alert = $row['issue_id'];
	}
	unset($db_query);
	
	if (($alert == 0)||($alert != $alert_id)) {
		$db_handle2 = new PDO("sqlite:databases/list.database.sqlite3");
		$db_handle3 = new PDO("sqlite:databases/alerts.database.sqlite3");

		//Remove Old Alert if Applicable
		if($alert != 0)  {
			$count = $db_handle3->exec("DELETE FROM faults WHERE device_id = '".$device_id."' AND vars = '".$variable."' AND issue_id = '".$alert."';");
		}
		
		//Find People to Alert
		$db_query = $db_handle2->query("SELECT alert_people FROM alert_list WHERE alert_id = '".$alert_id."';");
		foreach($db_query as $row) {
			$people = $row['alert_people'];
		}
		unset($db_query);
		$people = explode(",", $people);
		
		//Add Alert for each Person
		$i=0;
		do {
			$count = $db_handle4->exec("INSERT INTO faults(device_id, issue_id, Person_id, vars, sent) VALUES ('".$device_id."','".$alert_id."','".$people[$i]."','".$variable."' ,'n')");
			$i++;
		} while(isset($people[$i]));
		
	} else {
		//Do Nothing
	}

}

/*
	send_alert()
	Sends the email alerts as one message per person
*/
function send_alert() {
	$db_handle = new PDO("sqlite:databases/devices.database.sqlite3");
	$db_handle2 = new PDO("sqlite:databases/list.database.sqlite3");
	$db_handle3 = new PDO("sqlite:databases/alerts.database.sqlite3");
	$db_handle4 = new PDO("sqlite:databases/faults.database.sqlite3");
	// Find the people
	$db_query = $db_handle4->query("SELECT DISTINCT Person_id FROM faults WHERE sent = 'n';");
	foreach($db_query as $row) {
		$people[] = $row['Person_id'];
	}
	unset($db_query);
	if (empty($people)) {
		return TRUE;
	}
	$i=0;
	do {
	// Find Email Customisation
		$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'email_from';");
		foreach($db_query as $row) {
			$alert['form'] = $row['val'];
		}
		unset($db_query);
		$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'email_footer';");
		foreach($db_query as $row) {
			$alert['footer'] = $row['val'];
		}
		unset($db_query);
		
	//Get the persons info
		$db_query = $db_handle2->query("SELECT * FROM people_list WHERE id = '".$people[$i]."';");
		foreach($db_query as $row) {
			$alert['email'] = $row['email'];
			$alert['first'] = $row['first_name'];
			$alert['last'] = $row['last_name'];
		}
		unset($db_query);
		
	// Construct the Email Headers
		$to = $alert['email'];
		$subject = "Automatic System Alert";
		$headers = "From: ".$alert['form']."\r\nX-Mailer: PHP/".phpversion();
		$message = "Hello ".$alert['first']."\r\n";

	// get the persons alerts
			$db_query = $db_handle4->query("SELECT * FROM faults WHERE Person_id = '".$people[$i]."' AND sent = 'n' ORDER BY device_id, issue_id;");
			foreach($db_query as $row) {
				$alert['issue'][] = $row['issue_id'];
				$alert['device'][] = $row['device_id'];
				$alert['vars'][] = $row['vars'];
			}
			unset($db_query);
	// Construct Messages
		$ii=0;
		do {
			// Device Realname
			$db_query = $db_handle->query("SELECT hum_desc FROM snmp WHERE unique_id = '".$alert['device'][$ii]."';");
			foreach($db_query as $row) {
				$temp['device'] = $row['hum_desc'];
			}
			unset($db_query);
			// Human Message
			$db_query = $db_handle3->query("SELECT * FROM alerts WHERE id = '".$alert['issue'][$ii]."';");
			foreach($db_query as $row) {
				$temp['message'] = $row['message'];
			}
			unset($db_query);
			$message = $message.message_replace($temp['message'],$temp['device'],$alert['vars'][$ii])."\r\n";	
			unset($temp);
			$ii++;
		} while(isset($alert['device'][$ii]));
		
		$message = $message."\r\n\r\n".$alert['footer'];
	// SEND!
		mail($to,$subject,$message,$headers);
			
	// Edit the database entries
			$db_query = $db_handle4->exec("UPDATE faults SET sent='y' WHERE Person_id = '".$people[$i]."' AND sent = 'n';");
			unset($db_query);
		$i++;
		unset($alert);
	} while(isset($people[$i]));
	return TRUE;
}

/*
	reset_alerts($device_id)
	Clear any alerts in the database
*/
function reset_alerts($device_id) {
	$db_handle4 = new PDO("sqlite:databases/faults.database.sqlite3");
	$db_query = $db_handle4->exec("DELETE FROM faults WHERE device_id = '".$device_id."';");
	unset($db_query);
	return TRUE;
}

/*
	make_alert_hd($alert_id, $device_id, $variable)
	This constructs the helpdesk alert list
	NOTE: $variable is not an array but the next function to use the database will assume any commas (,) is a marker to seperate arrays
			so please remove any commas unless you are wanting it as an array.
*/
function make_alert_hd($alert_id, $device_id, $variable=NULL) {
	$alert = NULL;
	$db_handle4 = new PDO("sqlite:databases/faults.database.sqlite3");
	
	//Check for the Alert
	$db_query = $db_handle4->query("SELECT issue_id FROM helpdesk_faults WHERE device_id = '".$device_id."' AND vars = '".$variable."';");
	foreach($db_query as $row) {
		$alert = $row['issue_id'];
	}
	unset($db_query);
	
	if (($alert == 0)||($alert != $alert_id)) {
		$db_handle3 = new PDO("sqlite:databases/alerts.database.sqlite3");

		//Remove Old Alert if Applicable
		if($alert != 0)  {
			$count = $db_handle3->exec("DELETE FROM helpdesk_faults WHERE device_id = '".$device_id."' AND vars = '".$variable."' AND issue_id = '".$alert."';");
		}

		$count = $db_handle4->exec("INSERT INTO helpdesk_faults(device_id, issue_id,  vars, sent) VALUES ('".$device_id."','".$alert_id."','".$variable."' ,'n')");
		
	} else {
		//Do Nothing
	}
}

/*
	send_alert_hd()
	Sends the helpdesk alerts as one message per device
*/
function send_alert_hd() {
	$db_handle = new PDO("sqlite:databases/devices.database.sqlite3");
	$db_handle2 = new PDO("sqlite:databases/list.database.sqlite3");
	$db_handle3 = new PDO("sqlite:databases/alerts.database.sqlite3");
	$db_handle4 = new PDO("sqlite:databases/faults.database.sqlite3");
	// Find the device
	$db_query = $db_handle4->query("SELECT DISTINCT device_id FROM helpdesk_faults WHERE sent = 'n';");
	foreach($db_query as $row) {
		$device[] = $row['device_id'];
	}
	unset($db_query);
	if (empty($device)) {
		return TRUE;
	}
	// Find the helpdesk
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'whelp2';");
		foreach($db_query as $row) {
			$helpdesk = $row['val'];
		}
	unset($db_query);
	// If the helpdesk isn't configured
	if (empty($helpdesk)) {
		return TRUE;
	}
	// Find the helpdesk user
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'whelp2_api_ppass';");
		foreach($db_query as $row) {
			$ppass = $row['val'];
		}
	unset($db_query);
	
	$i=0;	
	do {
		// Find the device issues
		$db_query = $db_handle4->query("SELECT * FROM helpdesk_faults WHERE device_id = '".$device[$i]."' AND sent = 'n' ORDER BY device_id, issue_id;");
		foreach($db_query as $row) {
			$alert['issue'][] = $row['issue_id'];
			$alert['vars'][] = $row['vars'];
		}
		unset($db_query);
		$message = "";
		// Construct Messages
		$ii=0;
		do {
			// Device Realname
			$db_query = $db_handle->query("SELECT hum_desc FROM snmp WHERE unique_id = '".$device[$i]."';");
			foreach($db_query as $row) {
				$temp['device'] = $row['hum_desc'];
			}
			unset($db_query);
			// Human Message
			$db_query = $db_handle3->query("SELECT * FROM alerts WHERE id = '".$alert['issue'][$ii]."';");
			foreach($db_query as $row) {
				$temp['message'] = $row['message'];
			}
			unset($db_query);
			$message = $message.message_replace($temp['message'],$temp['device'],$alert['vars'][$ii])."\r\n";	
			unset($temp);
			$ii++;
		} while(isset($alert['issue'][$ii]));
		$message = $message."\r\n\r\nThis ticket was automatically generated.\r\nDo NOT Delete this ticket.";
		// PUT to API
		$URL = "http://".$helpdesk."/api.php?method=put&password=".$ppass."&type=question&data=new&cat=1&message=".urlencode($message);
		$XML = new SimpleXMLElement(@file_get_contents($URL));
		$id = $XML->question->id;

	// Edit the database entries to include the Helpdesk Ticket ID
			$db_query = $db_handle4->exec("UPDATE helpdesk_faults SET sent='".$id."' WHERE device_id = '".$device[$i]."' AND sent = 'n';");
			unset($db_query);
		$i++;
		unset($alert);
	} while(isset($device[$i]));
	return TRUE;
}

/*
	reset_alerts_hd($device_id)
	Clear any alerts in the database
*/
function reset_alerts_hd($device_id) {
	$db_handle2 = new PDO("sqlite:databases/list.database.sqlite3");
	$db_handle4 = new PDO("sqlite:databases/faults.database.sqlite3");
	$db_query = $db_handle4->query("SELECT sent FROM helpdesk_faults WHERE device_id = '".$device_id."' AND sent != 'n';");
	foreach($db_query as $row) {
		$ticket[] = $row['sent'];
	}
	unset($db_query);
	
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'whelp2';");
		foreach($db_query as $row) {
			$helpdesk = $row['val'];
		}
	unset($db_query);
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'whelp2_api_ppass';");
		foreach($db_query as $row) {
			$ppass = $row['val'];
		}
	unset($db_query);
	
	// PUT to API
	$i=0;
	do {
		$URL = "http://".$helpdesk."/api.php?method=put&password=".$ppass."&type=status&data=closed&id=".$ticket[$i];
		$XML = @file_get_contents($URL);
		$i++;
	} while(isset($ticket[$i]));
	
	$db_query = $db_handle4->exec("DELETE FROM helpdesk_faults WHERE device_id = '".$device_id."' AND sent != 'n';");
	unset($db_query);
	
	return TRUE;
}
?>