<?PHP

/*
	get_device_info($device_description)
	A function that returns the Human Readable Description, and ID's for the SNMP Device.
		This will only work if the device is reachable
	$device_description = SNMP Description
*/
function get_device_info($device_description) {
	$db_handle = new PDO("sqlite:databases/devices.database.sqlite3");
	$devices = $db_handle->query("SELECT * FROM snmp WHERE snmp_desc = '".$device_description."';");
	foreach($devices as $row) {
		$info['id'] = $row['snmp_id'];
		$info['desc'] = $row['hum_desc'];
		$info['uniq'] = $row['unique_id'];
	}
	return $info;
}

/*
	get_device_info_offline($id)
	A function that returns the Human Readable Description, and ID's for the SNMP Device.
		Designed for using when the devices is offline and using the last known Unique ID
	$id = Unique ID
*/
function get_device_info_offline($id) {
	$db_handle = new PDO("sqlite:databases/devices.database.sqlite3");
	$devices = $db_handle->query("SELECT * FROM snmp WHERE unique_id = '".$id."';");
	foreach($devices as $row) {
		$info['id'] = $row['snmp_id'];
		$info['desc'] = $row['hum_desc'];
		$info['uniq'] = $row['unique_id'];
	}
	return $info;
}

/*
	get_device_device_desc($ip, $community)
	Retrieves the SNMP Description from the device
	$ip = Device IP
	$community = Device Read Only Community
*/
function get_device_desc($ip, $community) {
	snmp_set_valueretrieval(SNMP_VALUE_PLAIN);
	$snmp = snmp2_get($ip,$community,"sysDescr.0");
	return $snmp;
}

/*
	check_device_id($ip, $id)
	This gets the current SNMP unique ID and then stores it in the list so if the device is unreachable, it can be reported.
	$ip = Device IP
	$id = Device Unique SNMP ID, not required.
*/
function check_deivce_id($ip, $id=NULL) {
	$db_handle = new PDO("sqlite:databases/devices.database.sqlite3");
	$db_handle2 = new PDO("sqlite:databases/list.database.sqlite3");
	$devices = $db_handle2->query("SELECT name FROM device_list WHERE ip = '".$ip."';");
	foreach($devices as $row) {
		$info['id'] = $row['name'];
	}
	unset($devices);	
	if (empty($id)) {
		return $info['id'];
	} else {
		if (($id != $info['id'])||(empty($info['id']))) {
			$devices = $db_handle2->query("UPDATE device_list SET name='".$id."' WHERE ip = '".$ip."';");
			return $id;
		} else {
			return $info['id'];
		}
		
	}
}
?>