<?PHP
/*
	Prototype CRON/Scheduled script for the SNMP device polling.
	Adam Boutcher
	bd84dz@student.sunderland.ac.uk / adam.boutcher@gmail.com
	Requires: PHP5, PHP-SNMP, PHP-SQLite (SQLite3 PDO)
*/
// Put a PHP4 check here...
date_default_timezone_set('Europe/London');

// This page will be for the XML Cache generation
$PAGE_NAME = "../cache/wifi_stats.xml";
$PAGE_OUTPUT = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
// Require The WiFi Functions
	require("functions/wifi/info.php");

// Database
	$db_handle = new PDO("sqlite:databases/devices.database.sqlite3");
	$db_handle2 = new PDO("sqlite:databases/list.database.sqlite3");
	$db_handle3 = new PDO("sqlite:databases/alerts.database.sqlite3");
	
// Limit the number of requests to every 15mins
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'cache_time';");
	foreach($db_query as $row) {
		$_CONFIG['cache_time'] = $row['val'];
	}
	unset($db_query);
	
// Get Config Variables
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'whelp2';");
	foreach($db_query as $row) {
		$_CONFIG['helpdesk'] = $row['val'];
	}
	unset($db_query);

	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'wifi_max_clients';");
	foreach($db_query as $row) {
		$_CONFIG['max'] = $row['val'];
	}
	unset($db_query);
	
	// Does the cache Exist before we start asking for dates and stuff...
	// Timestamps are in POSIX for easier comparison checks.
	if(file_exists($PAGE_NAME)) {
		// Get the cache modifcation time and then add the time we expect it to be when it needs regenerating.
		$PAGE_AGE = filemtime($PAGE_NAME);
		$NEW_AGE = $PAGE_AGE+$_CONFIG['cache_time'];
	} else {
		// No cache = make one!
		$NEW_AGE = 0;
	}

	// Is the expected re-cache time less than the time now?
	if ($NEW_AGE <= time()) {
	
		// Find the WiFi ID
		$db_query = $db_handle->query("SELECT * FROM types WHERE type = 'wifi';");
		foreach($db_query as $row) {
			$wifi_id = $row['id'];
		}
		unset($db_query);
		
		// Find the WiFi
		$db_query = $db_handle2->query("SELECT * FROM device_list WHERE type_id = '".$wifi_id."';");
		foreach($db_query as $row) {
			$wifi['id'][] = $row['id'];
			$wifi['ip'][] = $row['ip'];
			$wifi['ro_comm'][] = $row['ro_comm'];
		}
		unset($db_query);
		// Add the cache time, probably useful for something later.
		$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t<status cached=\"".date("g:i:sa - D jS F Y \(T\)")."\">";
		
		// Cycle through the wifi
		$i=0;
		do {
			// is the wifi reachable?
			if (ping($wifi['ip'][$i]) == "up") {
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t<wifi>";
				// get the info we need to then create something useful
				$wifi_description = get_device_desc($wifi['ip'][$i],$wifi['ro_comm'][$i]);
				$wifi_trans = get_device_info($wifi_description);
				$ap_count = get_wifi_count($wifi['ip'][$i],$wifi['ro_comm'][$i],$wifi['id'][$i]);
				$ap_count_max = get_wifi_count_max($wifi['ip'][$i],$wifi['ro_comm'][$i],$wifi['id'][$i]);
				$ap_names = get_wifi_names($wifi['ip'][$i],$wifi['ro_comm'][$i],$wifi['id'][$i]);
				$ap_ccount = get_wifi_clients($wifi['ip'][$i],$wifi['ro_comm'][$i],$wifi['id'][$i]);
				$wifi_id = check_deivce_id($wifi['ip'][$i], $wifi_trans['uniq']);
				$ii=0;
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<description>".$wifi_trans['desc']."</description>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<address>".$wifi['ip'][$i]."</address>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<ap_count>".$ap_count."</ap_count>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<ap_count_max>".$ap_count_max."</ap_count_max>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<client_count>".array_sum($ap_ccount)."</client_count>";
				// Cycle through the AP's
				do {
					$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<ap>";
					$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t\t<name>".$ap_names[$ii]."</name>";
					$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t\t<client_count>".$ap_ccount[$ii]."</client_count>";
					$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t</ap>";
					$ii++;
				} while (isset($ap_names[$ii]));
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<errors>0</errors>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t</wifi>";
			} else {
				// We have an offline device!
				// Get the little info we have and assume it's correct
				$wifi_id = check_deivce_id($wifi['ip'][$i]);
				// This should retrieve the last SNMP_Device Unique_ID that was detected. (See function for info)
				$wifi_trans = get_device_info_offline($wifi_id);
				// If we have device info display it, if not then display unknown.
				if(empty($wifi_trans)) {
					$wifi_trans['desc'] = "Unknown Device";
				}
				if(!empty($wifi_id)) {
// Offline Device Error (5)
					make_alert(5, $wifi_id);
					make_alert_hd(5, $wifi_id);
					$email++;
				}
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t<wifi>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<description>".$wifi_trans['desc']."</description>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<address>".$wifi['ip'][$i]."</address>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<ap_count>0</ap_count>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<client_count>0</client_count>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t\t<errors>1</errors>";
				$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t\t</wifi>";
			}
			// If the wifi has no errors this run then clear any errors from the log as they must be fixed.
			if($email == 0) {
				reset_alerts($wifi_trans['uniq']);
				reset_alerts_hd($wifi_trans['uniq']);
			}
			$i++;
		} while (isset($wifi['id'][$i]));
		$PAGE_OUTPUT = $PAGE_OUTPUT."\n\t</status>";
// Cache me baby
		// Open the cache file for overwriting.
		$fopen = @fopen($PAGE_NAME , "w");
		$write = @fwrite($fopen, $PAGE_OUTPUT);
		@fclose($fopen);
		// Log any cache errors
		if(($write != FALSE)&&(isset($write))) {
			@logger("success","Cache","Wifi Stats Cached.");
		} else {
			@logger("error","Cache","Error Caching Wifi Stats");
		}
	} else {
		@logger("success","Cache","Cache update for Wifi Stats Not needed");
	}
	
?>