<?PHP
// Unified display of both caches
ob_start();
	$db_handle2 = new PDO("sqlite:cron/databases/list.database.sqlite3");
	$db_query = $db_handle2->query("SELECT val FROM system WHERE var = 'wifi_max_clients';");
	foreach($db_query as $row) {
		$_CONFIG['max'] = $row['val'];
	}
	unset($db_query);
	
	$page = "home";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=9" />
		
		<meta name="author" lang="en" content="Adam Boutcher"/>

		<link rel="icon" href="favicon.ico" type="image/x-icon" />
		<link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
		<link rel="stylesheet" type="text/css" href="css/light.css" media="screen" title="Light Boxes"/>
		<link rel="stylesheet" type="text/css" href="css/graph.css" media="screen"/>
		
		<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.5.0/jquery.min.js"></script>
		<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.9/jquery-ui.min.js"></script>
		 
		<script type="text/javascript">
		$( dragload );	 
		function dragload() {
		  $('.block').draggable( {
			    containment: '.content',
			    cursor: 'move'
		  } );
		}
		</script>
		
		<title>Home - SNMP Mon</title>
	</head>
	<body>
		
		<div class="header">
			<div class="logo">
				<a href="#" title="SNMP Mon"><img src="img/logo.png" alt="SNMP Mon" /></a>
				<h1 class="title">gg-sim.co.uk</h1>
			</div>
				<?PHP require("inc/menu.display.php"); ?>
		</div>
		
		<div class="background">
			<div class="content">
<?PHP
date_default_timezone_set('Europe/London');
if(file_exists("cache/wifi_stats.xml")) {
	$wifi_XML = new SimpleXMLElement(@file_get_contents("cache/wifi_stats.xml"));
	$colours = array("yellow","cyan","magenta");
	$i = 0;
	do {
		if ($wifi_XML->wifi[$i]->errors > 0) {
			$bg = "style=\"background:#FFFFCC;\" ";
		} else {
			$bg = NULL;
		}
		echo "<div class=\"block\" ".$bg.">";
			echo "<div style=\"float:right;\"><img src=\"img/devices/wifi.png\" alt=\"WiFi\"/></div>";
			echo "<h3>".$wifi_XML->wifi[$i]->description."</strong></h3>";
			echo "<br/><p>";
				echo "<strong>Number of APs: </strong><em>".$wifi_XML->wifi[$i]->ap_count."</em> of <em>".$wifi_XML->wifi[$i]->ap_count_max."</em><br/>";
				echo "<strong>Address: </strong><em>".$wifi_XML->wifi[$i]->address."</em><br/>";
				echo "<strong>Clients: </strong><em>".$wifi_XML->wifi[$i]->client_count."</em><br/>";
			echo "</p>";
			echo "<br/><p>";
				echo "<strong>Access Point Stats</strong>";
			$ii=0;
			do {
			echo "<div>";
				echo "<p><em>".$wifi_XML->wifi[$i]->ap[$ii]->name."</em><br/>";
				echo "<div class=\"bar\">";
					if ($wifi_XML->wifi[$i]->ap[$ii]->client_count <= 5) {
						// Green
						$colour = "#3F0";
					} elseif ($wifi_XML->wifi[$i]->ap[$ii]->client_count <= $_CONFIG['max']) {
						// Threshold (yellow)
						$colour = "yellow";
					} else {
						// Danger
						$colour = "red";
					}
					$size = (($wifi_XML->wifi[$i]->ap[$ii]->client_count /35)*100);
					echo "<div class=\"fill\" style=\"width:".$size."%; background:".$colour."; color:black;\">";
						echo "<p><em>".$wifi_XML->wifi[$i]->ap[$ii]->client_count."</em> Clients Connected</p>";
					echo "</div>";
				echo "</div>";
			echo "</p></div>";
				$ii++;
			} while (isset($wifi_XML->wifi[$i]->ap[$ii]));
		echo "</p></div>";
		$i++;
	} while(isset($wifi_XML->wifi[$i]->address));
}
if(file_exists("cache/printer_stats.xml")) {
	$printer_XML = new SimpleXMLElement(@file_get_contents("cache/printer_stats.xml"));
	$colours = array("yellow","cyan","magenta");
	$i = 0;
	do {
		if ($printer_XML->printer[$i]->errors > 0) {
			$bg = "style=\"background:#FFFFCC;\" ";
		} else {
			$bg = NULL;
		}
		echo "<div class=\"block\" ".$bg.">";
			echo "<div style=\"float:right;\"><img src=\"img/devices/laser printer.png\" alt=\"Laser Printer\"/></div>";
			echo "<h3>".$printer_XML->printer[$i]->description."</strong></h3>";
			echo "<br/><p>";
				echo "<strong>Status: </strong><em>".ucwords(strtolower($printer_XML->printer[$i]->status))."</em><br/>";
				echo "<strong>Address: </strong><em>".$printer_XML->printer[$i]->address."</em><br/>";
				echo "<strong>Pages: </strong><em>".$printer_XML->printer[$i]->pages."</em>";
			echo "</p>";
			echo "<br/><p>";
				echo "<strong>Consumable Levels:</strong>";
				if (!empty($printer_XML->printer[$i]->consumables)) {
					foreach($printer_XML->printer[$i]->consumables->children() as $child) {
						if (in_array($child->getName(),$colours)) {
							$bg = $child->getName();
							$text = "black";
						} else {
							$bg = "black";
							$text = "white";
						}
						echo "<div>";
							echo "<p>".$child->attributes()."</p>";
							echo "<div class=\"bar\">";
								echo "<div class=\"fill\" style=\"width:".$child."%; background:".$bg."; color:".$text.";\">";
									echo "<p><em>".$child."</em>% Remaining</p>";
								echo "</div>";
							echo "</div>";
						echo "</div>";
					}
				}
			echo "</p>";
		echo "</div>";
		$i++;
	} while(isset($printer_XML->printer[$i]->address));	
}
if((!file_exists("cache/printer_stats.xml"))&&(!file_exists("cache/wifi_stats.xml"))) {
?>
				<div class="notice">
					<div class="icon">
						<img src="img/notice/warning.png" alt="Warning"/>
					</div>
					<div class="text">
						<h2>No Cache</h2>
						<p>There is no cache available to display any information.</p>
					</div>
				</div>

<?PHP
}
?>
				<div class="clear_both"></div>
			</div>
		</div>
		<div class="footer">
			<div class="leftfoot">
				&nbsp;
			</div>
			<div class="rightfoot">
<?PHP 
				if(file_exists("cache/wifi_stats.xml")) {
					echo "WiFi: <em>".$wifi_XML->attributes()."</em>";
				} else {
					echo "WiFi <em>No Cache</em>";
				}
				echo "<br/>";
				if(file_exists("cache/printer_stats.xml")) {
					echo "Printer: <em>".$printer_XML->attributes()."</em>";
				} else {
					echo "Printer <em>No Cache</em>";
				}
?>
				<br/><a href="force.update.php">Force Cache Update</a>
			</div>
			<div class="clear_both"><hr/></div>
			<div class="leftfoot">
				Copyright &copy; <?PHP echo date("Y"); ?> - <em>Adam Boutcher</em>.
			</div>
			<div class="rightfoot">
				&nbsp;
			</div>
		</div>

<script type="text/javascript">
var javascript_countdown = function () {
	var time_left = 10; //number of seconds for countdown
	var output_element_id = 'javascript_countdown_time';
	var keep_counting = 1;
	var no_time_left_message = 'Refreshing...';
 
	function countdown() {
		if(time_left < 2) {
			keep_counting = 0;
		}
		time_left = time_left - 1;
	}
 
	function add_leading_zero(n) {
		if(n.toString().length < 2) {
			return '0' + n;
		} else {
			return n;
		}
	}
 
	function format_output() {
		var hours, minutes, seconds;
		seconds = time_left % 60;
		minutes = Math.floor(time_left / 60) % 60;
 
		seconds = add_leading_zero( seconds );
		minutes = add_leading_zero( minutes );
 
		return minutes + ':' + seconds;
	}
 
	function show_time_left() {
		document.getElementById(output_element_id).innerHTML = format_output();//time_left;
	}
 
	function no_time_left() {
		document.getElementById(output_element_id).innerHTML = no_time_left_message;
	}
 
	return {
		count: function () {
			countdown();
			show_time_left();
		},
		timer: function () {
			javascript_countdown.count();
 
			if(keep_counting) {
				setTimeout("javascript_countdown.timer();", 1000);
			} else {
				no_time_left();
			}
		},
		//Kristian Messer requested recalculation of time that is left
		setTimeLeft: function (t) {
			time_left = t;
			if(keep_counting == 0) {
				javascript_countdown.timer();
			}
		},
		init: function (t, element_id) {
			time_left = t;
			output_element_id = element_id;
			javascript_countdown.timer();
		}
	};
}();
		javascript_countdown.init(300, 'javascript_countdown_time');
	</script>

	</body>
</html>
<?PHP
header("refresh:300;url=".$_SERVER['PHP_SELF']);
ob_flush();
?>